#!/usr/bin/env python
# encoding: iso-8859-15
#
#Minë. Mundo Interactivo-Narrativo en Español [Tierra-Media]
#Copyright (C) 2002  Pablo Ruiz Múzquiz
#
#
#This program is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program; if not, write to the Free Software
#Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#
#
#Fichero: mine.py

"""Código inicial de arranque del servidor."""

import os
import logging
import logging.config
logging.config.fileConfig("minelog.ini")        # Esto hay que configurarlo
fecha_minelog = os.path.getmtime("minelog.ini") # antes de cargar cualquier
log = logging.getLogger("Basico")               # otro módulo

import sys
from logo import *
from utils import *
import Mundo
import InterfazPJ
import Connection
import CronoMine

DIRECCION_IP = ""
PUERTO = 2000

def nuevo_cliente(handler):
    """Responde a una peticion de un cliente.

    Se acepta la conexión y crea un nuevo InterfazPJ asociado
    a la conexión nueva.
    """
    conn = handler.accept(None, None)
    conn.set_page_prompt("--- Pulsar Intro ---")
    interfaz = InterfazPJ.InterfazPJ(conn)
    log.info("Conectado nuevo cliente desde " + conn.ip + ".")


def preparar_salida():
    """Ejecuta todas las acciones de limpieza necesarias al salir."""
    log.info("Saliendo del programa...")
    
#    # Enviar al limbo a todos los jugadores que esten conectados
#    for personaje in Mundo.pjs_activos.values():
#        log.info("Enviando al limbo a " + personaje.id)
#    	Mundo.enviar_al_limbo(personaje)

    Mundo.conn_handler.close_all()
    Mundo.salvar_todo()
    log.info("\n\n********CRASH******\n\n")
    logging.shutdown()


# Entrada y bucle principal de la aplicacion

print color(33) + logo() + finl
print

Mundo.conn_handler = Connection.ConnectionHandler(DIRECCION_IP, PUERTO, nuevo_cliente)
print "Servidor activado y a la escucha en puerto " + str(PUERTO) + "." 
print "Pulsar Control-C para detener."
print
log.info("Iniciado servidor en puerto %d", PUERTO)

Mundo.cronoMine_control = CronoMine.control()

# Al salir del programa hay que salvar todas las salas y personajes
sys.exitfunc = preparar_salida

Mundo.inicializar()

try:

    while 1:
	Mundo.conn_handler.run()
	Mundo.cronoMine_control.run()
	if os.path.getmtime("minelog.ini") != fecha_minelog:
            logging.config.fileConfig("minelog.ini")

except KeyboardInterrupt:
    log.info("Interrumpido manualmente por el operador")

